# Copyright (c) 2014, 2015 Dave Love, Liverpool University
# The licence for this file is as for the package itself.

# fixme: soname for libraries -- how in #?!@ cmake?
#        zeromq version

Name:		phish
Version:	17Feb15
Release:	1%{?dist}
Summary:	Framework for processing streaming data in parallel

License:	BSD
URL:		http://www.sandia.gov/~sjplimp/phish.html
# via http://www.sandia.gov/~sjplimp/download.html
Source0:	phish.tar.gz
# fix minnow mpi linking
Patch1:		phish-makefile.patch
# fix python path
Patch2:		phish-pybin.patch
# add shebang, MPI search path
Patch3:		phish-bait.patch
BuildRequires:	cmake openmpi-devel mpich-devel graphviz-devel

%global desc \
The PHISH library is the chief component of a simple framework for\
processing large volumes of data, either in a real-time streaming\
context or from files.\
\
PHISH is a lightweight framework which a set of independent processes\
can use to exchange data as they run on the same desktop machine, on\
processors of a parallel machine, or on different machines across a\
network.  This enables them to work in a coordinated parallel fashion\
to perform computations on either streaming or archived data.\
\
The PHISH distribution includes a simple, portable library for\
performing data exchanges in useful patterns either via MPI\
message-passing or ZMQ sockets.  PHISH input scripts are used to\
describe a data-processing algorithm, and an additional tool provided\
in the PHISH distribution converts the script into a form that can be\
launched as a parallel job.\
\
This is an MPI-only version.

%description
%desc

%package openmpi
Summary:	Framework for processing streaming data in parallel - openmpi
Requires:	openmpi

%description openmpi
%desc

This is the openmpi version.

%package openmpi-devel
Summary:	Development files for %name
Requires:	%name-openmpi%{?_isa} = %version-%release, openmpi-devel

%description openmpi-devel
Development files for %name-openmpi.

%package mpich
Summary:	Framework for processing streaming data in parallel - mpich
Requires:	mpich

%description mpich
%desc

This is the mpich version.

%package mpich-devel
Summary:	Development files for %name
Requires:	%name-mpich%{?_isa} = %version-%release, mpich-devel

%description mpich-devel
Development files for %name-mpich.

%prep
%setup -q
%patch1 -p0
%patch2 -p0
%patch3 -p1
chmod -x minnow/ring-worker.py python/phish/__init__.py src/hashlittle.cpp
mkdir openmpi mpich


%build
pushd openmpi
%_openmpi_load
%cmake -DBUILD_ZMQ_BACKEND=OFF ..
make %{?_smp_mflags}
%_openmpi_unload
popd
pushd mpich
%_mpich_load
%cmake -DBUILD_ZMQ_BACKEND=OFF ..
make %{?_smp_mflags}
%_mpich_unload
popd


%install
rm -rf $RPM_BUILD_ROOT

%global doinst \
make install DESTDIR=$RPM_BUILD_ROOT\
# no cmake switch to use these\
mkdir -p $RPM_BUILD_ROOT$MPI_INCLUDE $RPM_BUILD_ROOT$MPI_LIB\
mkdir -p $RPM_BUILD_ROOT$MPI_BIN/phish $RPM_BUILD_ROOT%python_sitelib\
mv $RPM_BUILD_ROOT%_includedir/*.h* $RPM_BUILD_ROOT$MPI_INCLUDE\
mv $RPM_BUILD_ROOT/usr/lib/lib* $RPM_BUILD_ROOT$MPI_LIB\
ln -s %python_sitelib/phish/bait/bait.py $RPM_BUILD_ROOT$MPI_BIN\
for f in minnow/*-mpi; do\
  mv $f $RPM_BUILD_ROOT$MPI_BIN/phish/$(basename $f -mpi)\
done

%_openmpi_load
pushd openmpi
%doinst
popd
%_openmpi_unload

%_mpich_load
pushd openmpi
%doinst
popd
%_mpich_unload

cp -a python/phish $RPM_BUILD_ROOT%python_sitelib
cp -p bait/*.py $RPM_BUILD_ROOT%python_sitelib/phish/bait
rm $RPM_BUILD_ROOT%python_sitelib/phish/bait/zmq*
cp -a minnow example
pushd example/minnow
rm -f *zmq Makefile Makefile.*.*
#rm -r CM* *.cmake		# all cmake bits
popd


%clean
rm -rf $RPM_BUILD_ROOT


%files openmpi
%doc LICENSE README doc/* example
%_libdir/openmpi/lib/*
%_libdir/openmpi/bin/*
%python_sitelib/phish

%files openmpi-devel
%_includedir/openmpi-%_arch/*

%files mpich
%doc LICENSE README doc/* example
%_libdir/mpich/lib/*
%_libdir/mpich/bin/*
%python_sitelib/phish

%files mpich-devel
%_includedir/mpich-%_arch/*


%changelog
* Tue Feb 17 2015 Dave Love <d.love@liverpool.ac.uk> - 17Feb15-1
- New version
- Drop patches 4 and 5

* Mon Jan 19 2015 Dave Love <d.love@liverpool.ac.uk> - 16Jan15-1
- New version
- Fix build
- Remove -mpi suffix from minnows
- mpich version

* Sun Jan 18 2015 Dave Love <d.love@liverpool.ac.uk> - 16Jan1-1
- New version
- Drop header patch, split minnow patch

* Tue Jan 13 2015 Dave Love <d.love@liverpool.ac.uk> - 14Jan13-1
- Initial packaging
